Codeforces Round #283 (Div. 2) E

2024-01-28 06:18
文章标签 codeforces round div 283

本文主要是介绍Codeforces Round #283 (Div. 2) E,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

E. Distributing Parts


        题意:一个节目,有n个部分,每部分有一个范围;有m个人,每个人有个能力范围,能表演若干部分。如果人的范围包含了某个部分的范围,就能表演那个部分,问如何分配。

        思路:贪心+平衡二叉树(set)上查找。将每个部分和人按范围的下界排序,然后对每个部分,把下界满足表演要求的人加到集合里去维护,然后贪心找一个上界尽量小的人去表演这一部分。

        注意在集合中查找时,不要用std::lower_bound(),它的复杂度是O(n)。。。


#include <stdio.h>
#include <iostream>
#include <queue>
#include <memory.h>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;const int maxn=100010;struct Part{int a,b;int id;bool operator<(const Part& q)const{return a<q.a;}
}part[maxn];struct Actor{int c,d;int id;bool operator<(const Actor& q)const{return c<q.c;}
}actor[maxn];struct Node{int x;int id;Node(int x,int id):x(x),id(id){	}bool operator<(const Node& q)const{if(x==q.x)return id<q.id;return x<q.x;}
};int cnt[maxn];
int ans[maxn];int main(){int n,m;scanf("%d",&n);for(int i=0;i<n;i++){scanf("%d%d",&part[i].a,&part[i].b);part[i].id=i+1;}scanf("%d",&m);for(int i=0;i<m;i++){scanf("%d%d%d",&actor[i].c,&actor[i].d,&cnt[i]);actor[i].id=i+1;}sort(part,part+n);sort(actor,actor+m);bool ok=1;int k=0;set<Node> Set;set<Node>::iterator it;for(int i=0;i<n;i++){		//枚举每个部分 for(;k<m;k++){if(part[i].a>=actor[k].c){Set.insert(Node(actor[k].d,actor[k].id));	//对当前部分,把下界满足的演员加到集合里去维护 }else{break;}}it=Set.lower_bound(Node(part[i].b,0));	//贪心找上界尽量小的演员去表演该部分 if(it!=Set.end()){ans[part[i].id]=(*it).id;if(--cnt[(*it).id-1]==0){Set.erase(it);}}else{ok=0;break;}}if(ok){printf("YES\n");for(int i=1;i<=n;i++){printf("%d ",ans[i]);}printf("\n");}else{printf("NO\n");}return 0;
}


这篇关于Codeforces Round #283 (Div. 2) E的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/652716

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There